/*	 PPP dupes/limits checker ver 0.0.5
	 Written by Alexey Semenov (c) 1999-2000
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/time.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#include "config.h"

//------------------------------------------------
char *get_time () {

   char *time_string;

     time_t timv = time (0);
     time_string=ctime ( &timv );
     time_string[strlen(time_string)-1]=0;
     return (time_string);
 }
//----------------------------
  check_tm(pt)
    char *pt;
{
        char qs[512], tstr[128], *ptr, *ptr2;
        int i,n;
	float a_time, u_time;
        FILE *fl1;

i = 1;
a_time = u_time = 0;


  if ((fl1=fopen(TIME_LIMIT_FILE,"r"))==NULL) return (i);

 while ((fgets(qs, 511, fl1))!=NULL) {
  if ((qs[0]=='#')||(qs[0]==';')) continue;
   ptr=strtok (qs," \t");


    if (strcmp(ptr, pt)==0) {
				strtok (NULL," \t");
				ptr=strtok (NULL," \t");
				a_time=atof(ptr);
				break;
			    }
 }
 fclose (fl1);


  if (a_time==0) return (i);

   strcpy (tstr, SAC);
    strcat (tstr, pt);
     strcat (tstr, SAC_END);
      strcat (tstr, SAC_TEMP_FILE);

	system (tstr);

 if ((fl1=fopen(SAC_TEMP_FILE,"r"))==NULL) return (i);
  if ( fgets(tstr, 127, fl1)==NULL) return (i);
    fclose (fl1);
    unlink (SAC_TEMP_FILE);

   strtok(tstr," \r\n\t");
    ptr=strtok(NULL," \r\n\t");
     u_time=atof(ptr);

 if (u_time >= a_time) i=0;

return (i);
}
//----------------------------
  check_td(pt)
    char *pt;
{
        char qs[512], tstr[128], *ptr, *ptr2, *rptr, *rptr2, *ts;
        int i,n;
        float ad_time, ud_time;
        FILE *fl1;

i = 1;
ad_time = ud_time = 0;


  if ((fl1=fopen(TIME_LIMIT_FILE,"r"))==NULL) return (i);

 while ((fgets(qs, 511, fl1))!=NULL) {
  if ((qs[0]=='#')||(qs[0]==';')) continue;
   ptr=strtok (qs," \t");


    if (strcmp(ptr, pt)==0) {
                                ptr=strtok (NULL," \t");
                                ad_time=atof(ptr);
                                break;
                            }
 }
 fclose (fl1);


  if (ad_time==0) return (i);


   strcpy (tstr, SAC);
    strcat (tstr,SAC_DAY);
     strcat (tstr, pt);
      strcat (tstr, SAC_END);
       strcat (tstr, SAC_TEMP_FILE);

   system (tstr);

ts=get_time();

  strtok (ts," \t");
   ptr=strtok (NULL, " \t");
     ptr2=strtok (NULL, " \t");

if ((fl1=fopen(SAC_TEMP_FILE,"r"))==NULL) return (i);

//--------

 while ((fgets(qs, 511, fl1))!=NULL) {


  rptr=strtok(qs," \t");
  rptr2=strtok(NULL," \t");

  if  ((strcmp(ptr,rptr)!=0)||(strcmp(ptr2,rptr2)!=0)) continue;

     strtok (NULL," \t");
      ptr=strtok (NULL," \t");
       ud_time=atof(ptr);
	break;
 }

fclose (fl1);
 unlink (SAC_TEMP_FILE);

 if (ud_time >= ad_time) i=0;

  return (i);
}
//-----------------------------

  check_d(pt)
    char *pt;
{
	char tstr[128], *ptr;
	int i,n;
	FILE *fl1;

 i=1;

   strcpy (tstr, WHO_STRT);
    strcat (tstr, pt);
     strcat (tstr, WHO_END);
      strcat (tstr, WHO_TEMP_FILE);

	system (tstr);

 if ((fl1=fopen(WHO_TEMP_FILE,"r"))==NULL) return (i);
  if ( fgets(tstr, 127, fl1)==NULL) return (i);
   ptr=strtok(tstr," \r\n\t");
 
 if ( (strcmp(ptr,"0")!=0) && (strcmp(ptr,"1")!=0) ) i=0;

fclose (fl1);
unlink (WHO_TEMP_FILE);
return (i);
}

//=================================================== MAIN
int
main()
{
 char qs[512], qs1[512], *pt, *file_buffer;
 char *time_string;
 struct stat statv;
 int i;
 FILE *fl1; 


if ((fl1=fopen(PAP_FILE,"r"))==NULL) { perror (PAP_FILE); exit (1); }
  if (stat(PAP_FILE,&statv)!=0) { perror (PAP_FILE); exit (1); }
    if ((file_buffer=calloc(statv.st_size+1000,1))==NULL) {printf ("malloc error\n");exit (1);}
 i=0;

while ((fgets(qs, 511, fl1))!=NULL) {

 if ((qs[0]=='#')||(qs[0]==';'))    { strcat (file_buffer, qs);; continue; }

  strcpy(qs1,qs);
   strtok (qs1," \t");
    pt=strtok (qs1,"\"");

  if (!check_d(pt)) {	i=1;
			strcat(file_buffer, "#+++DUPES, ACCOUNT DISABLED "); 
			strcat (file_buffer, get_time() );
			strcat(file_buffer, "+++>");
			system (MAIL_DUPES);
			system (KILL_PPP);
		     }


  else if (!check_tm(pt)) {
			i=1;
			strcat(file_buffer, "#+++M_TIME_LIMIT, ACCOUNT DISABLED ");
			strcat (file_buffer, get_time() );
			strcat(file_buffer, "+++>");
			system (MAIL_MTIME_LIMIT);
			system (KILL_PPP);
		     }

  else if (!check_td(pt)) {
			i=1;
                        strcat(file_buffer, "#+++D_TIME_LIMIT, ACCOUNT DISABLED ");
                        strcat (file_buffer, get_time() );
                        strcat(file_buffer, "+++>");
//			system (MAIL_DTIME_LIMIT);
			system (KILL_PPP);
		     }




strcat (file_buffer, qs);

}

fclose (fl1);


//-----------------------------

if (i) {
   fl1=fopen(PAP_FILE_TEMP,"w");
   fprintf(fl1,"%s",file_buffer);
   fclose(fl1);
	}

free (file_buffer);
}
